SystemOrganization addCategory: #GGController!

Object subclass: #GGController
	instanceVariableNames: 'ownerController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GGController'!

!GGController class methodsFor: 'instance creation' stamp: 'HwaJong 3/17/2014 22:37'!
newWithOwnerController: aGGController 
	^self new ownerController: aGGController! !

!GGController methodsFor: 'morph' stamp: 'HwaJong 3/23/2014 20:45'!
inspectControllerButton: q
	^q button: 'ic' action: #inspect! !

!GGController methodsFor: 'accessing' stamp: 'HwaJong 3/17/2014 22:33'!
model
	^self ownerController listModel selection! !

!GGController methodsFor: 'morph' stamp: 'HwaJong 3/20/2014 13:31'!
morph
	"|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q button: 'show bitizen' action: #goPageSelectBitizen.
		q button: 'evict!!' action: #evictBitizen.}"
	^self subclassResponsibility! !

!GGController methodsFor: 'accessing' stamp: 'HwaJong 3/17/2014 22:33'!
ownerController
	^ ownerController! !

!GGController methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 20:54'!
ownerController: anObject 
	ownerController := anObject ! !

!GGController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 10:34'!
refresh
	self subclassResponsibility! !

!GGController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 10:43'!
refreshFromRootController
	self rootController refresh! !

!GGController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 10:42'!
rootController
	^ownerController 
		ifNil: [ self ]
		ifNotNil: [ ownerController rootController ]! !

GGController subclass: #GGDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GGController'!

!GGDetailController methodsFor: 'testing' stamp: 'HwaJong 3/19/2014 20:51'!
canPresent: anObject 
	"^aTTAction isKindOf: TTShowBitizenAction"
	self subclassResponsibility! !

!GGDetailController methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/22/2014 21:18'!
detailControllerPriority
	^9999! !

!GGDetailController methodsFor: 'testing' stamp: 'HwaJong 3/27/2014 15:50'!
hasModel
	^self ownerListControllerHasSelection! !

!GGDetailController methodsFor: 'testing' stamp: 'HwaJong 3/27/2014 15:47'!
ownerListControllerHasSelection
	^self ownerController listHasSelection ! !

!GGDetailController methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/16/2014 18:48'!
ownersListModel

	^ownerController listModel! !

!GGDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 10:26'!
refresh
	self updateWithModel! !

!GGDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/16/2014 22:38'!
updateWithModel
	self subclassResponsibility! !

GGDetailController subclass: #GGDetailControllerGeneratingDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GGController'!

!GGDetailControllerGeneratingDetailController methodsFor: 'testing' stamp: 'HwaJong 3/22/2014 21:14'!
canPresent: anObject 
	^true! !

!GGDetailControllerGeneratingDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:18'!
detailControllerPriority
	^0! !

!GGDetailControllerGeneratingDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/23/2014 20:35'!
generateDetailController
	| senderSystemCategory newControllerClass newName codeString |
	newName := UIManager default request: 'Name the generated controller class'.
	newName isEmptyOrNil ifTrue: [ ^self ].
	senderSystemCategory := thisContext sender receiver model model class category.
	newControllerClass := self class superclass subclass: newName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		category: senderSystemCategory.
	ownerController detailController addPageControllerOfClass: newControllerClass.
	ownerController detailController updateWithModel.

	codeString := String streamContents: [:stream|
		stream nextPutAll: #pageControllerClassesForPolymorphicPageController.
		stream cr; tab.
		stream nextPut: $^.
		stream nextPut: ${.
		ownerController pageControllerClassesForPolymorphicPageController, { newControllerClass }
			do: [:each| stream cr; tab; tab. stream print: each. stream nextPutAll: ' . '].
		stream cr; tab.
		stream nextPut: $}.
		]. 
	ownerController class compile: codeString.! !

!GGDetailControllerGeneratingDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/22/2014 21:06'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column:
		{q staticLabel: 'No controller for selected item.'.
		q button: 'generate controller' action: #generateDetailController}! !

!GGDetailControllerGeneratingDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/22/2014 21:03'!
updateWithModel
	! !

GGController subclass: #GGListController
	instanceVariableNames: 'filterString sortingDescriptorListModel detailController listModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GGController'!

!GGListController methodsFor: 'list-action' stamp: 'HwaJong 3/18/2014 11:36'!
addItem
	self subclassResponsibility! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 16:02'!
addItemButton: q

	^q button: '+' action: #addItem enabled: #canAddItem.! !

!GGListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 11:33'!
arrayOfStringsForListMorphOfElement: anObject
	"^{
		anObject titleString. 
		anObject summaryString. 
		anObject colorString. 
	}"
	^self subclassResponsibility! !

!GGListController methodsFor: 'testing' stamp: 'HwaJong 3/16/2014 15:53'!
canAddItem
	^true! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 11:26'!
changedWhenItemRemoved
	self subclassResponsibility! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/30/2014 10:25'!
changedWhenRefreshList! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 10:50'!
detailController
	^detailController setDefault: #detailControllerDefault for: self withSetter: #detailController:! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 10:47'!
detailController: anObject 
	detailController := anObject ! !

!GGListController methodsFor: 'defaults' stamp: 'HwaJong 3/25/2014 20:26'!
detailControllerDefault

	^GGPolymorphicPageController newWithOwnerController: self pageControllerClasses: (self pageControllerClassesForPolymorphicPageController, {GGDetailControllerGeneratingDetailController})! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:30'!
filterString
	^filterString setDefault: #filterStringDefault for: self withSetter: #filterString:! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/29/2014 09:31'!
filterString: aString 
	filterString := aString.
	self changed: #filterString.
	self refreshListMaintainingSelection.! !

!GGListController methodsFor: 'defaults' stamp: 'HwaJong 3/12/2014 21:30'!
filterStringDefault
	^String new! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 15:58'!
filterTextMorph: q

	^(q text: #filterString) autoAccept: true! !

!GGListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 11:34'!
filteredCollectionForListModel
	"|upper|
	upper := self filterString asUppercase.
	^ownerController model bitizens select: [:each| upper isEmpty or: [(each bitName findString: upper) > 0] ]"
	^self subclassResponsibility! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 20:40'!
inspectButton: q 
	^q button: 'i' action: #inspectSelectedItem enabled: #itemIsSelected! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/29/2014 12:30'!
inspectDetailControllerButton: q 
	^q button: 'ip' action: #inspectDetailControllerSelectedItem enabled: #itemIsSelected! !

!GGListController methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/21/2014 13:26'!
inspectDetailControllerSelectedItem
	self detailController correspondingDetailController inspect  ! !

!GGListController methodsFor: 'actions' stamp: 'HwaJong 3/12/2014 22:46'!
inspectSelectedItem
	self listModel selection inspect.! !

!GGListController methodsFor: 'testing' stamp: 'HwaJong 3/12/2014 21:30'!
itemIsSelected
	^self listModel hasSelection! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 19:46'!
itemSortingDropList: q 
	^q dropList: #sorting! !

!GGListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 19:46'!
listElementAt: anInteger 
	^self arrayOfStringsForListMorphOfElement: (self listModel list at: anInteger)! !

!GGListController methodsFor: 'testing' stamp: 'HwaJong 3/12/2014 21:30'!
listHasSelection

	^self listModel hasSelection! !

!GGListController methodsFor: 'list' stamp: 'HwaJong 3/12/2014 21:30'!
listIndex
	^self listModel selectionIndex! !

!GGListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 20:21'!
listIndex: anInteger
	self listModel selectionIndex: anInteger.
	self changed: #listIndex.
	self changed: #itemIsSelected.
	
	self operationWhenSelectionIsChanged.! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:30'!
listModel

	^listModel setDefault: #listModelDefault for: self withSetter: #listModel:! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:30'!
listModel: aTGListModel
		
	listModel := aTGListModel! !

!GGListController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 21:08'!
listModelDefault

	^TGListModel new list: (self filteredCollectionForListModel asSortedCollection: (self sortingDescriptorListModel selection))! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 15:59'!
listMorph: q

	^q fastMultiListSize: #listSize element: #listElementAt: index: #listIndex! !

!GGListController methodsFor: 'list' stamp: 'HwaJong 3/14/2014 15:51'!
listSelection: anObject
	self listModel selection: anObject.
	self changed: #listIndex.
	self changed: #itemIsSelected.
	
	self operationWhenSelectionIsChanged.! !

!GGListController methodsFor: 'list' stamp: 'HwaJong 3/12/2014 21:30'!
listSize
	^self listModel list size! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 20:35'!
morph
	^self subclassResponsibility! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/19/2014 21:31'!
morphOfMeAndMyDetail: q
	^q
		splitLeft: self morph
		splitRight: self detailController morph! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/16/2014 22:38'!
operationWhenSelectionIsChanged

	detailController ifNotNil: [detailController updateWithModel]
! !

!GGListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 19:44'!
pageControllerClassesForPolymorphicPageController

	"^{ BitizenListOfCommercialFloorController. BitizenListOfResidentFloorController}"
	^self subclassResponsibility! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 10:30'!
refresh
	self refreshListMaintainingSelection! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/15/2014 15:43'!
refreshElements
	self changed: #listElementAt: ! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/30/2014 10:25'!
refreshList
	self listModel: nil.
	self changed: #listSize.
	self refreshElements.
	self changed: #canAddItem.
	self changed: #itemIsSelected.
	self changedWhenRefreshList.! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 19:19'!
refreshListAndSelect: anObject

	(self listModel list includes: anObject) ifFalse: 
		[self filterString: nil].
	self refreshList.
	self listModel selection: anObject.
	self refreshSelectionAndDetail.! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 19:21'!
refreshListAndSelectionIndex: anInteger

	(self listModel canAccessAt: anInteger) ifFalse:
		[self filterString: nil].
	self refreshList.
	self listModel selectionIndex: anInteger.
	self refreshSelectionAndDetail.! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/19/2014 11:18'!
refreshListButton: q 
	^q button: 'refresh' action: #refreshListMaintainingSelection.! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/17/2014 11:33'!
refreshListMaintainingSelection
	self listModel
		ifHasSelection: 
			[:sel |  
			self refreshListAndSelect: sel] 
		ifDoesNotHaveSelection: 
			[self refreshList.
			self refreshSelectionAndDetail]! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/15/2014 15:43'!
refreshSelection
	self refreshElements! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/15/2014 15:40'!
refreshSelectionAndDetail
	self listIndex: (self listModel selectionIndex)! !

!GGListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 11:32'!
removalSelector
	"^#removeMyObject:"
	^self subclassResponsibility! !

!GGListController methodsFor: 'morph' stamp: 'HwaJong 3/16/2014 19:53'!
removeItemButton: q 
	^q button: '-' action: #removeSelectedItem enabled: #itemIsSelected.! !

!GGListController methodsFor: 'actions' stamp: 'HwaJong 3/17/2014 13:15'!
removeSelectedItem

	self removeSelectedItemWithSelector: self removalSelector.! !

!GGListController methodsFor: 'actions' stamp: 'HwaJong 3/17/2014 10:57'!
removeSelectedItemWithSelector: aSymbol
	ownerController model perform: aSymbol with: self listModel selection.
	self refreshList.
	self changedWhenItemRemoved.! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:30'!
sortingDescriptorListModel

	^sortingDescriptorListModel setDefault: #sortingDescriptorListModelDefault for: self withSetter: #sortingDescriptorListModel:! !

!GGListController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:30'!
sortingDescriptorListModel: anObject
		
	sortingDescriptorListModel := anObject! !

!GGListController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 20:51'!
sortingDescriptorListModelDefault

	^TGListModel new
		list: self sortingDescriptorsDefault;
		selectionIndex: 1! !

!GGListController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 20:51'!
sortingDescriptorsDefault

	^{ 
		PrintingDifferently subject: [:a :b| true ] printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'no sorting' ]
	}! !

!GGListController methodsFor: 'sorting' stamp: 'HwaJong 3/12/2014 21:30'!
sortingDropList
	^self sortingDescriptorListModel list! !

!GGListController methodsFor: 'sorting' stamp: 'HwaJong 3/12/2014 21:30'!
sortingDropListIndex
	^self sortingDescriptorListModel selectionIndex! !

!GGListController methodsFor: 'sorting' stamp: 'HwaJong 3/15/2014 14:10'!
sortingDropListIndex: anInteger 
	self sortingDescriptorListModel selectionIndex: anInteger.
	self refreshList.! !

!GGListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 11:28'!
updateListAfterAddingItem
	self subclassResponsibility! !

GGController subclass: #GGPolymorphicPageController
	instanceVariableNames: 'tabGroupMorph correspondingDetailControllers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GGController'!

!GGPolymorphicPageController class methodsFor: 'instance creation' stamp: 'HwaJong 3/17/2014 23:06'!
newWithOwnerController: aGGController pageControllerClasses: aCollection 
	|instance|
	instance := self newWithOwnerController: aGGController.
	aCollection do: [ :each| instance addPageControllerOfClass: each ].
	^instance! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:53'!
addPageControllerOfClass: aClass 
	|controllerInstance|
	controllerInstance := aClass newWithOwnerController: ownerController.
	self correspondingDetailControllers
		add: controllerInstance.
	self tabGroupMorph addPage: controllerInstance morph label: 'whatever'! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:16'!
correspondingDetailController

	|defaultController|
	defaultController := nil.
	^ownerController listModel 
		ifHasSelection:  [:sel| 
			| hits |
			hits := self correspondingDetailControllers select: [ :each| each canPresent: self model ].
			hits isEmpty
				ifTrue: [defaultController]
				ifFalse: [(hits asSortedCollection: (UnarySortDescriptor ascendingBy: #detailControllerPriority)) last]]
		ifDoesNotHaveSelection: [defaultController]! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 19:58'!
correspondingDetailControllers
	^correspondingDetailControllers setDefault: #correspondingDetailControllersDefault for: self withSetter: #correspondingDetailControllers:! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 19:59'!
correspondingDetailControllers: anOrderedCollection 
	correspondingDetailControllers := anOrderedCollection! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 20:42'!
correspondingDetailControllersDefault
	^OrderedCollection new! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:56'!
morph
	^self tabGroupMorph! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 20:30'!
pageIndexOfDetailController: aGGController

	^aGGController
		ifNil: [0]
		ifNotNil: [self correspondingDetailControllers indexOf: aGGController]! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 20:45'!
selectItem: anObject
	| controller |
	controller := self correspondingDetailController.
	controller listModel selection: anObject.
	controller refreshSelectionAndDetail.! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:50'!
tabGroupMorph
	^tabGroupMorph setDefault: #tabGroupMorphDefault for: self withSetter: #tabGroupMorph:! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:51'!
tabGroupMorph: aTapGroupMorph
	tabGroupMorph := aTapGroupMorph! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:50'!
tabGroupMorphDefault
	|t|
	t := TabGroupMorph new.
	t tabSelectorMorph delete.
	^t! !

!GGPolymorphicPageController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/18/2014 10:26'!
updateWithModel
	
	| corr |
	corr := self correspondingDetailController.
	corr ifNotNil: [:that| that refresh].
	tabGroupMorph selectedPageIndex: (self pageIndexOfDetailController: corr)! !
